/** I N C L U D E S ****************************** ****************************/
#include <p18f4550.h>
#include "typedefs.h"
#include "usb.h"
#include "io_cfg.h"
#include "usbdrv.h"
#if defined(PIC18F4550_PICDEM_FS_USB) // Configuration bits for PICDEM FS USB Demo Board
#pragma config PLLDIV = 5 // (20 MHz crystal on PICDEM FS USB board)
#pragma config CPUDIV = OSC1_PLL2
#pragma config USBDIV = 2 // Clock source from 96MHz PLL/2
#pragma config FOSC = HSPLL_HS
#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config PWRT = OFF
#pragma config BOR = ON
#pragma config BORV = 2
#pragma config VREGEN = ON //USB Voltage Regulator
#pragma config WDT = OFF
#pragma config WDTPS = 32768
#pragma config MCLRE = ON
#pragma config LPT1OSC = OFF
#pragma config PBADEN = OFF //NOTE: modifying this value here won't have an effect

 #pragma config CCP2MX = ON
#pragma config STVREN = ON
#pragma config LVP = OFF
 #pragma config ICPRT = OFF
#pragma config XINST = OFF 
#pragma config CP0 = OFF
#pragma config CP1 = OFF
#pragma config CP2 = OFF
#pragma config CP3 = OFF
#pragma config CPB = OFF
#pragma config CPD = OFF
#pragma config WRT0 = OFF
#pragma config WRT1 = OFF
#pragma config WRT2 = OFF
#pragma config WRT3 = OFF
#pragma config WRTB = OFF 
#pragma config WRTC = OFF
#pragma config WRTD = OFF
#pragma config EBTR0 = OFF
#pragma config EBTR1 = OFF
#pragma config EBTR2 = OFF
#pragma config EBTR3 = OFF
#pragma config EBTRB = OFF

else
#error Not a supported board (yet), make sure the proper board is selected in usbcfg.h, and if so, set configuration bits in __FILE__, line __LINE__
#endif
/** V A R I A B L E S ****************************** **************************/
#pragma udata

char *conv_char_chaine (char val); 
void init_timer0(void);
void interrupt_prog(void);
void interrupt_prog_conv(void);
void init_conv(void);
void sel_voix0(void);
/** V E C T O R R E M A P P I N G ****************************** *************/

/** D E C L A R A T I O N S ****************************** ********************/
static volatile float input;
static volatile char res[10], asc[3];
static volatile int i;


void main(void)
{
init_timer0(); 
init_conv();

ADRESH=0x00 ; 
res[0]= 0x00; 

while (1) 
{ 
sel_voix0(); 

asc[i]=*conv_char_chaine( res[i]);  

/*---------------------------| Envoie des donnes sur le bus |----------------------------------*/

if(!mHIDTxIsBusy()) 
{
HIDTxReport(asc,0); 
}

}  

}

/*----------------------------------------------------------------------------------------------*/
char *conv_char_chaine(char val) 
{ 
unsigned char uni, diz,cent,z;
char chaine[3];
if(val>=99)cent=val/100;
if(val<=99)cent=0;
z=val-cent;
if(z>=9)diz=z/10;
if(z<=9)diz=0;
diz= val-(cent*100);
uni= val-(cent*100)-(diz*10);
chaine[0]=cent|0x30;
chaine[1]=diz|0x30;
chaine[2]=uni|0x30;

return(chaine);
} 
/*----------------------------------------------------------------------------------------------*/
void init_timer0(void) 
{ 
T0CONbits.TMR0ON=1; 
T0CONbits.PSA =0; 
T0CON.T0CS= 0; 
T0CONbits.PS2 = 1; 
T0CONbits.PS1 = 1; 
T0CONbits.PS0= 1;
T0CONbits.RP0 = 0 ; 
T0CONbits.T0IE = 1; 
T0CONbits.GIE = 1;

}
/*----------------------------------------------------------------------------------------------*/
void interrupt_prog(void)
{ 

if ( INTCON.TMR0IF ) 
{ 
ADCON0bits.GO_DONE=1; 
INTCON.TMR0IF = 0; 
T0CON.TMR0 = 0; // RAZ du timer pour qu'il recommence  compter jusque 65536

}

}
/*----------------------------------------------------------------------------------------------*/
void interrupt_prog_conv(void)
{ 
if (ADIF==1) 
{ 
ADCON0bits.GO_DONE=0; 
res[i]=ADRESH; 
}
} 
/*----------------------------------------------------------------------------------------------*/ 
void init_conv(void) 
{ 
ADCON0bits.ADON = 1 ; 

ADCON1bits.PCFG0 = 0 ; 
ADCON1bits.PCFG1 = 1 ;  
ADCON1bits.PCFG2 = 0 ; 
ADCON1bits.PCFG3 = 0 ;  

ADCON1bits.VCFG0 = 0 ; 
ADCON1bits.VCFG1 = 0 ; 


ADCON2bits.ADCS0 = 1 ; 
ADCON2bits.ADCS1 = 0 ; 
ADCON2bits.ADCS2 = 1 ; 

ADCON2bits.ACQT0 = 0 ; 
ADCON2bits.ACQT1 = 0 ; 
ADCON2bits.ACQT2 = 0 ; 

ADCON2bits.ADFM = 0 ; 

}
/*----------------------------------------------------------------------------------------------*/
void sel_voix0(void)
{ 
ADCON0bits.CHS0 = 0 ; 
ADCON0bits.CHS1 = 0 ; 
ADCON0bits.CHS2 = 0 ; 
ADCON0bits.CHS3 = 0 ; 
} 
